'use strict';

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var _require = require('preact'),
    h = _require.h,
    Component = _require.Component;

var shortid = require('shortid');

/**
 * A checkbox input, compatible with "withValidation" hoc.
 * @prop {String} name - name attribute
 * @prop {String} label - label text (html allowed)
 * @prop {Boolean} value - initial value
 * @prop {Boolean} on_dark - adjust css for dark backgrounds
 * @prop {Function} onValueChange - function called with the value when it
 * changes
 */

var BooleanInput = function (_Component) {
  _inherits(BooleanInput, _Component);

  function BooleanInput(props) {
    _classCallCheck(this, BooleanInput);

    var _this = _possibleConstructorReturn(this, (BooleanInput.__proto__ || Object.getPrototypeOf(BooleanInput)).call(this, props));

    _this.state = { value: props.value || false };
    _this.shortid = shortid.generate();
    return _this;
  }

  _createClass(BooleanInput, [{
    key: 'componentDidUpdate',
    value: function componentDidUpdate(prevProps, prevState) {
      // when the value changes, validate and reflect to parent if applicable
      if (this.state.value !== prevState.value) {
        this.props.onValueChange && this.props.onValueChange(this.state.value);
      }

      // if a parent changes the value, reflect it to the state
      if (this.props.value !== prevProps.value) {
        this.setState({ value: this.props.value });
      }
    }
  }, {
    key: 'render',
    value: function render() {
      var _this2 = this;

      var classes = ['g-boolean-input'];
      if (this.props.on_dark) {
        classes.push('on-dark');
      }
      return h(
        'div',
        { 'class': classes.join(' ') },
        h('input', {
          type: 'checkbox',
          name: this.props.name,
          id: 'id-' + this.props.name + '-' + this.shortid,
          ref: function ref(el) {
            return _this2.inputEl = el;
          },
          value: this.state.value,
          onChange: function onChange(e) {
            return _this2.setState({ value: e.target.checked });
          }
        }),
        h(
          'label',
          { htmlFor: 'id-' + this.props.name + '-' + this.shortid },
          h('span', { dangerouslySetInnerHTML: { __html: this.props.label } })
        )
      );
    }
  }]);

  return BooleanInput;
}(Component);

module.exports = BooleanInput;
